/*********************************************************
 * Aperture Photometory:
 *
 *    Determin MODE
 *
 *       Input  : *pData    : POINT Data
 *       Input  : dNdata    : INT   Number of Data
 *       Output : fMode     : FLOAT Mode
 *
 *
 *       Ver.2.0 : 20040303 : Masayuki Akiyama
 **********************************************************
 */

#include "acquisition.h"

float ac_mode(const float *data, const int ndata)
{  
    int   i,j;
    int   n_part; /* ^[$BJ,3d?t^[(B */
    float mode_value;
    float *f, fmin, fmax, df;
    int  *num;
    int  nmax, nmin;
    int  imax, imin;
    int  n_remain;
    int  n_cycle;

    n_part = 5;
 
    num = (int *)malloc(sizeof(int)*(n_part));
    f = (float *)malloc(sizeof(float)*(n_part + 1));

    fmin = fmax = *(data);

    for(i=0; i<=ndata-1; i++){
          if(*(data+i) >= fmax) fmax = *(data+i);
          if(*(data+i) <= fmin) fmin = *(data+i);
    }

    if( ndata < n_part * 10 ){
       printf("Cannot Determin Mode");
       mode_value = 0;
    }
    else n_remain = ndata;

    n_cycle = 0;

 while(n_remain >= n_part * 10)
   {

      df = ( fmax - fmin ) / n_part;

      /* ^[$B%R%9%H%0%i%`$N:n@.^[(B */
      for(i=0; i<=n_part; i++)
        {
        *(f+i) = fmin + i * df;
        *(num+i) = 0;
        }

      for(i=0; i<=ndata-1; i++)
  {
        for(j=0; j<=n_part-1; j++)
    {
          if( *(data+i) >= *(f+j) && *(data+i) <= *(f+j+1))
      {
            *(num+j) = *(num+j) + 1;
      }
    }
        }

       nmax = nmin = 0;
       for(i=0; i<=n_part-1; i++)
   {

#ifdef DEBUG
         printf("MODE log 1 : %d \n",*(num+i));
#endif

         if( *(num+i) >= nmax )
              {
              nmax = *(num+i);
              imax = i;
        }
         if( *(num+i) <= nmin )
              {
              nmin = *(num+i);
              imin = i;
        }
         }
      n_remain = *(num + imax);
      fmin = *(f+imax);
      fmax = *(f+imax+1);
      n_cycle = n_cycle + 1;
      printf("MODE log %d %d %d %f \n", n_cycle, imax, n_remain, fmin);
    }
   mode_value = ( fmin + fmax ) / 2.0;

   return mode_value;
   free(f);
   free(num);
}
