/*****************************************************
 *  MOIRCS Acquisition:
 *
 *   Read Data File 
 *
 *   Input : cFile   : Input Data File Name
 *   Output: fHoleX  : X coordinate list
 *   Output: fHoleY  : Y coordinate list
 *   Output: iStat   : <0 if iC=0, or if fileread err
 *                   : =iC : Number of data read
 *
 *     Version 1.0 20050915 Masayuki Akiyama
 *****************************************************
 */

#include  "acquisition.h"

#undef DEBUG

int file_read_hole(const char *cFile, float *fHoleX, float *fHoleY, float *fHoleR)
{
   int    iNum;
   FILE   *pFile;
   char   cLine[1000];
   char   cData[30][10];
   int    iStart;       /* Reading status */
   int    iStat;
   int    iC;

   iStart = 0;
   iStat = 0;
   iC = 0;

   pFile = fopen(cFile, "r");
   
   while(fgets (cLine, 1000, pFile)){
      iNum = sscanf(cLine, "%s ", cData[0]);
      if( iNum < 1){
          iStat = -2;
          break;
      }
      else{
         iStart = 1;
         iNum = sscanf(cLine, "%s %s %s ", cData[0], cData[1], cData[2]);

         *(fHoleX+iC) = atof(cData[0]);
         *(fHoleY+iC) = atof(cData[1]);
         *(fHoleR+iC) = atof(cData[2]);

         iC=iC+1;
      }
   }

   if( iStart == 0 ){ iStat = -1; }
   else if( iC == 0 ){ iStat = -1; }
   else { iStat = iC; }

   fclose(pFile);
   return  iStat;
}
