/*****************************************************
 *  MOIRCS Acquisition:
 *
 *   Read Data File 
 *
 *   Input : cFile   : Input Data File Name
 *   Output: fHoleX  : X coordinate list
 *   Output: fHoleY  : Y coordinate list
 *   Output: iStat   : <0 if iC=0, or if fileread err
 *                   : =iC : Number of data read
 *
 *     Version 1.0 20050915 Masayuki Akiyama
 *****************************************************
 */

#include  "acquisition.h"

#undef DEBUG

int file_read_mdp(const char *cFile, float *fHoleX, float *fHoleY, const char *cType)
{
   int    iNum;
   FILE   *pFile;
   char   cLine[1000];
   char   cData[30][10];
   int    iStart;       /* Reading status */
   int    iStat;
   int    iC;
   float  fRawX, fRawY;

   iStart = 0;
   iStat = 0;
   iC = 0;

   pFile = fopen(cFile, "r");
   
   while(fgets (cLine, 1000, pFile)){
      iNum = sscanf(cLine, "%s ", cData[0]);
      if( iNum < 1){
          iStat = -2;
          break;
      }
      else{
         iStart = 1;
         if( strstr( cLine, cType ) != NULL){
            iNum = sscanf(cLine, "%s %s ", cData[0], cData[1]);

// MDP from FOCAS preimage
//            *(fHoleX+iC) = (2.0*1060.5-atof(cData[0]))*PLATE_FOCAS/PLATE_MOIRCS;
//            *(fHoleY+iC) = XLEN_FOCAS - (2.0*1820.5-atof(cData[1]))*PLATE_FOCAS/PLATE_MOIRCS;
// MDP from MOIRCS itself
          *(fHoleX+iC) = atof(cData[0]);
          *(fHoleY+iC) = atof(cData[1]);

            iC=iC+1;
         }
      }
   }

   if( iStart == 0 ){ iStat = -1; }
   else if( iC == 0 ){ iStat = -1; }
   else { iStat = iC; }

   fclose(pFile);
   return  iStat;
}
