# -------------------------------------------
#
#   Make distortion-corrected
#     mosaiced MOIRCS image
#
#        2005/09/15 Masayuki Akiyama
#
# -------------------------------------------

procedure make_mosaic( inchip1, inchip2 , outchip12 )

file    inchip1       {prompt = ' Input raw data chip1 :'}
file    inchip2       {prompt = ' Input raw data chip2 :'}
file    outchip12     {prompt = ' Output mosaiced image :'}

begin
    string    raw_chip1, raw_chip2
    string    geo_chip1, geo_chip2
    string    mos_chip12

    string    dist_chip1, dist_chip2
    string    tmpdist_chip1, tmpdist_chip2

    string    mask_chip1, mask_chip2
    string    geomask_chip1, geomask_chip2
    string    geomask_chip1pl, geomask_chip2pl

    string    tmplist1

    raw_chip1 = inchip1
    raw_chip2 = inchip2

    geo_chip1 = "geo_chip1.fits"
    geo_chip2 = "geo_chip2.fits"

    dist_chip1 = "mcsdistmosaic1c_050814.dbs"
    dist_chip2 = "mcsdistmosaic2c_050814.dbs"

    tmpdist_chip1 = "mcsdistmosaic1c.dat"
    tmpdist_chip2 = "mcsdistmosaic2c.dat"

    mask_chip1 = "tmpmask1r.fits"
    mask_chip2 = "tmpmask2r.fits"

    geomask_chip1 = "geomask_chip1.fits"
    geomask_chip2 = "geomask_chip2.fits"

    geomask_chip1pl = "geomask_chip1.pl"
    geomask_chip2pl = "geomask_chip2.pl"

    tmplist1 = "tmplist1"

    mos_chip12 = outchip12

    imdelete(geo_chip1, ver-)
    imdelete(geo_chip2, ver-)
    delete(geomask_chip1, ver-)
    delete(geomask_chip2, ver-)
    delete(geomask_chip1pl, ver-)
    delete(geomask_chip2pl, ver-)
    delete(tmplist1, ver-)
    imdelete(mos_chip12, ver-)

# Chip1
    geotran.boundary="constant"
    geotran.constant=0
    geotran.interpolant="linear"
    geotran( raw_chip1, geo_chip1, dist_chip1, tmpdist_chip1 )

    geotran.boundary="constant"
    geotran.constant=1
    geotran.interpolant="linear"
    geotran( mask_chip1, geomask_chip1, dist_chip1, tmpdist_chip1 )
    imcopy(geomask_chip1, geomask_chip1pl)

    hedit( geo_chip1, "BPM", geomask_chip1pl, add+, update+, ver-, show- )

# Chip2
    geotran.boundary="constant"
    geotran.constant=0
    geotran.interpolant="linear"
    geotran( raw_chip2, geo_chip2, dist_chip2, tmpdist_chip2 )

    geotran.boundary="constant"
    geotran.constant=1
    geotran.interpolant="linear"
    geotran( mask_chip2, geomask_chip2, dist_chip2, tmpdist_chip2 )
    imcopy(geomask_chip2, geomask_chip2pl)

    hedit( geo_chip2, "BPM", geomask_chip2pl, add+, update+, ver-, show- )

# Combine
    print( geo_chip1, > tmplist1 )
    print( geo_chip2, >> tmplist1 )

    imcombine.combine="average"
    imcombine.reject="avsig"
    imcombine.masktype="goodvalue"
    imcombine.maskvalue=0
    imcombine("@"//tmplist1, mos_chip12 ) 
   
# Delete tempolary files
    imdelete(geo_chip1, ver-)
    imdelete(geo_chip2, ver-)
    delete(geomask_chip1, ver-)
    delete(geomask_chip2, ver-)
    delete(geomask_chip1pl, ver-)
    delete(geomask_chip2pl, ver-)
    delete(tmplist1, ver-)

 print("This procedure ended ......")
 print(" ")

end
