"""
mklist.py - make file list for iraf task
2007.08.21 YOSHIKAWA, Tomohiro
$Log: not supported by cvs2svn $
Revision 1.1  2007/09/03 08:24:31  tomohiro
make file list for iraf task


"""
import sys,math
from pyraf import iraf
import pyfits
from iraftool import fileutil, tmpfile

def mklist(infile, expr='yes', prefix='', suffix='', base=False, getlist=False):
    if getlist:
        outlist = []
    if expr == 'yes':
        for line in fileutil.fileparse(infile, ext=True, base=base):
            if getlist:
                outlist.append(prefix+line[0]+suffix)
            else:
                print prefix+line[0]+suffix
    else:
        inlist = fileutil.fileparse(infile, ext=True, base=base)
        tmplist = []
        for il in inlist:
            tmplist.append('%s[%d]'%(il[0], il[1]))
        hstmp = tmpfile.TmpFile('mklist')
        hstmp.writelist(tmplist)
        hsout = iraf.hselect('@'+hstmp.path, '$I', expr, Stdout=1)
        hstmp.close()
        for line in hsout:
            line = line.strip()
            line = line[:-3]
            if getlist:
                outlist.append(prefix+line+suffix)
            else:
                print prefix+line+suffix
    if getlist:
        return outlist

def wikitable(infile, head, expr='yes', filename=True, comment=False):
    head = head.split(',')
    sys.stdout.write('|')
    if filename:
        sys.stdout.write('file name|')
    for key in head:
        sys.stdout.write(key+'|')
    if comment:
        sys.stdout.write('comment|')
    sys.stdout.write('h\n')
    for fl in mklist(infile, expr, getlist=True):
        pf = pyfits.open(fileutil.osimg(fl))
        if filename:
            sys.stdout.write('|'+fl+'|')
        else:
            sys.stdout.write('|')
        for key in head:
            try:
                vl = pf[0].header[key]
            except KeyError:
                vl = '-'
            try:
                if abs(vl) < 0.1:
                    sys.stdout.write('%.3e|'%(vl))
                else:
                    sys.stdout.write('%.2f|'%(vl))
            except TypeError:
                sys.stdout.write('%s|'%(vl))
        if comment:
            sys.stdout.write('|')
        sys.stdout.write('\n')
