"""
  filter.py - tools for filter
  2011.01.17. YOSHIKAWA, Tomohiro
"""
import pyfits
from spectool import specdata

def res2fits(resfile, fitsfile):
    """
    transform *.res (hyperz) filter file to FITS file
     resfile  - input *.res (hyperz) filter file
     fitsfile - output fits filter file
    """
    
    l_wl = []
    l_tr = []
    for line in open(resfile):
        line.strip()
        id, wl, tr = line.split()
        wl = float(wl)
        tr = float(tr)
        l_wl.append(wl)
        l_tr.append(tr)
    
    specdata.mkspecdata(l_wl, l_tr, outfile=fitsfile, filter=True)

        
